#include "ext.h"
#include "z_dsp.h" 

void *last_class;

typedef struct _last
{
    t_pxobject	x_obj;
	
    double 		s_rate;
    long		sigvs;
	
    void 		*l_out;					// double outlet for peak
										// void 		*l_out2;				// last flag (1=limit, 0 = no limit)
	
} t_last, *t_last_ptr;

t_int *last_perform(t_int *w);
void *last_new(double hold_time_ms,double seuil);
void last_dsp(t_last *x, t_signal **sp, short *count);
// void last_assist(t_last *x, void *b, long m, long a, char *s);
void last_free(t_last *x);
void last_debug(t_last *x);

void main(void)
{
    setup((t_messlist **) &last_class, (method) last_new, (method)last_free, (short)sizeof(t_last), 0L,A_DEFFLOAT,A_DEFFLOAT,0);
    addmess((method)last_dsp, "dsp", A_CANT, 0);
	// addmess((method)last_assist,"assist",A_CANT,0);
	addmess((method)last_debug,"debug",0);
    post("gn.last~ Intel Only compiled %s %s @ Gilbert Nouno",__DATE__,__TIME__);
	dsp_initclass(); // set object class to work with MSP
	rescopy('STR#',4100);
}

/* void last_assist(t_last *x, void *b, long m, long a, char *s)
{
	assist_string(4100,m,a,1,2,s);
}*/

void *last_new(double hold_time_ms,double seuil)
{
    t_last *x = (t_last *)newobject(last_class);
    dsp_setup((t_pxobject *)x,1); // last has one input signal
								  // x->l_out 	= outlet_new((t_pxobject *)x, 0L); // one control outlet
    outlet_new((t_pxobject *)x, "signal");
	
    x->x_obj.z_misc	=	Z_NO_INPLACE; // in & out independants    
    
    x->s_rate		=	44100;			// peut-on demander le sample rate ici ???????????????
    return (x);
}

void last_free(t_last *x) {
	dsp_free((t_pxobject *)x);
}

void last_dsp(t_last *x, t_signal **sp, short *count)
{
	x->s_rate	=	sys_getsr();
	x->sigvs	=	sys_getblksize(); // ne marche pas pourquoi ???
	dsp_add(last_perform, 4, x, sp[0]->s_vec, sp[1]->s_vec, sp[0]->s_n);
}

t_int *last_perform(t_int *w)	{
	float		*in, *out, *in_copy, *out_copy;
	double		vector_peak;
	float		last;
	
	long		n,n_copy;
	
	t_last *x=	(t_last *)(w[1])	;
	in 			= 	(float *)(w[2])		;		// vecteur d'entre
	out 		= 	(float *)(w[3])		;		// vecteur de sortie
	n 			= 	w[4]				;		// sigvs
	
	vector_peak		=	0				;
	
	in_copy		=	in					;
	out_copy	=	out					;
	n_copy		=	n					;
	
	/*while (n--) {
		if ( *in > vector_peak) vector_peak=*in;
		*in++;
	}*/
	
	n = n_copy;
	last = *(in +	n - 1);
	
	while (n--) {
		*out++ = last;
	}
		
	return (w+5);
}

void last_debug(t_last *x)	{
	post("s_rate =%f", x->s_rate);
	post("sigvs  =%f", x->sigvs);
}
